/*
 * Created by victoria on 2021-05-12.
 */

#pragma once

#include "device_service.h"
#include "qomemo.h"

#include <QXmppClientExtension.h>

namespace QXmpp::Omemo {

class Manager : public QXmppClientExtension {
  Q_OBJECT;

public:
  Manager();
  ~Manager() override = default;

  bool handleStanza(const QDomElement &stanza) override;

public slots:
  void fetchOwnDevices();

signals:
  void deviceListReceived(const QString& jid, const DeviceList& list);

protected:
  void setClient(QXmppClient *client) override;

private:
  QScopedPointer<DeviceService> deviceService;
};

} // namespace QXmpp::Omemo
